/******************************************************************************
*                                                                             *
*    calclib.h                                   Copyright(c) 2007 itow,y.    *
*                                                                             *
******************************************************************************/


#ifndef CALC_LIB_H
#define CALC_LIB_H


#ifndef CL_USE_DOUBLE
typedef long double clValue;
#else
typedef double clValue;
#endif
#ifndef UNICODE
typedef char clChar;
#else
typedef wchar_t clChar;
#endif
typedef __int64 clInt64;
typedef unsigned __int64 clUInt64;

#define CL_MAX_DIGITS 14	/* őL */
#define CL_MAX_SYMBOL 16	/* ʎq̍ő咷(null܂) */

/* G[R[h */
typedef enum {
	CL_ERR_OK,				/* I */
	CL_ERR_SYNTAX,			/* \G[ */
	CL_ERR_BRACKET,			/* ʂ̑ΉG[ */
	CL_ERR_OVERFLOW,		/* I[o[t[ */
	CL_ERR_UNDERFLOW,		/* A_[t[ */
	CL_ERR_TOOLARGESYMBOL,	/* ʎq */
	CL_ERR_UNKNOWNSYMBOL,	/* m̎ʎq */
	CL_ERR_DIVIDEZERO,		/* 0Z */
	CL_ERR_ARGUMENT,		/* ֐̈s */
	CL_ERR_LOSS,			/*  */
	CL_ERR_UNKNOWN			/* m */
} clError;


clError clCalc(const clChar *pExpression,clValue *pAnswer);
clError clFloatToDec(clValue Value,clChar *pString);
clError clFloatToHex(clValue Value,clChar *pString,int nBits);
clError clFloatToBin(clValue Value,clChar *pString,int nBits);


#endif	/* ndef CALC_LIB_H */
